<?php
/**
* @version 1.0.0
* @package RSMembership! bitpay 1.0.0
* @copyright (C) 2012 www.bitpay.ir
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/
error_reporting(0);
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.plugin.plugin' );
jimport( 'joomla.html.parameter' );

if (file_exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsmembership'.DS.'helpers'.DS.'rsmembership.php'))
	require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsmembership'.DS.'helpers'.DS.'rsmembership.php');

class plgSystemRSMembershipbitpay extends JPlugin
{
	function canRun()
	{
		return file_exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsmembership'.DS.'helpers'.DS.'rsmembership.php');
	}

	function plgSystemRSMembershipbitpay(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->_plugin =& JPluginHelper::getPlugin('system', 'rsmembershipbitpay');
		$this->_params = new JParameter($this->_plugin->params);

		if (!$this->canRun()) return;
		RSMembership::addPlugin('دروازه پرداخت bitpay', 'rsmembershipbitpay');
	}
    public function onAfterRender()
    {
        if(isset($_POST['trans_id'])){
            $this->onPaymentNotification();
        }
    }

	function onMembershipPayment($plugin, $data, $extra, $membership, $transaction)
	{
		if (!$this->canRun()) return;
		if ($plugin != $this->_plugin->name) return false;
        $id_get = $_POST['id_get'];
        $trans_id = $_POST['trans_id'];
        $url = 'https://bitpay.ir/payment/gateway-send';
    	$api = $this->_params->get('api');
        $amount = $transaction->price;

        $redirect = urlencode(JURI::base().'index.php?option=com_rsmembership&task=thankyou');

        $result = $this->send($url,$api,$amount,$redirect);
        if($result > 0 && is_numeric($result)){
            $go = "https://bitpay.ir/payment/gateway-$result";
            $transaction->custom = $result;
            $html = 'در حال وصل شدن به درگاه...<META http-equiv="refresh" content="3;URL='.$go.'">';
        }else{
            $html = "در ارتباط با درگاه خطايي به وجود آمد : $result";
        }

		return $html;
	}
    public function onPaymentNotification()
    {
        if ( !$this->canRun( ) )
        {
        }
        else
        {
            $database = JFactory::getDBO();;
            $url = 'https://bitpay.ir/payment/gateway-result-second';
            $api = $this->_params->get('api');
            $trans_id = $_POST['trans_id'];
            $id_get = $_POST['id_get'];
            $result = $this->get($url,$api,$trans_id,$id_get);
            $database->setQuery( "SELECT * FROM #__rsmembership_transactions WHERE `custom`='".$id_get."' AND `status`!='completed' AND `gateway`='دروازه پرداخت bitpay'" );
            $transaction = $database->loadObject( );
            if ( empty( $transaction ) )
            {
                echo 'اطلاعاتي در رباطه با درخواست شما يافت نشد';
            }
            else
            {

                if($result == 1){
                    RSMembership::approve($transaction->id);
                    $database->setQuery( "UPDATE #__rsmembership_transactions SET `hash`='".$trans_id."' WHERE `id`='".$transaction->id."' LIMIT 1" );
                    $database->query();
                    echo 'پرداخت شما با موفقيت صورت گرفت';
                }else{
                    echo "مشکلي در پرداخت شما صورت گرفت ، شماره خطا: $result";
                }
            }

        }
    }
    public function send($url,$api,$amount,$redirect){
        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,$url);
        curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&amount=$amount&redirect=$redirect");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
        $res = curl_exec($ch);
        curl_close($ch);
        return $res;
    }
    public function get($url,$api,$trans_id,$id_get){
        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,$url);
        curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
        $res = curl_exec($ch);
        curl_close($ch);
        return $res;
    }

}